package Prograf;
use Data::Dumper;
use GlobalesSimusol;
use Algebraico;
use TraAbrev;
use Ayudas;
use strict;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&prograficar);
};
END();
our %nombreshash = ('TIME'=>1,'TIEMPO'=>1);
# aqui se guardan referencias a las variables propias

# abril 2006 en el paraplot los numeros se refieren a las variables propias
# si no se indican indices es porque son los naturales
# ----------------------------------------------------------------------------
sub prograficar{
  comfin('com prograficar',@_);
  # prepara archivo .paraplot con información para gráficos.
  my ($refcircuito) = @_;
  my $archguardar = $refcircuito->{PROPIOSINDIA}; 
  my $archguardarcongnus = $refcircuito->{CORTOSINDIA};
  my $PROPIO = $refcircuito->{PROPIO};
  my $CORTO = $refcircuito->{CORTO};
  my $date = scalar localtime((stat "$CORTO")[9]);
  if ($opt_hash{todas}) {
      $archguardar = "$archguardar"."_$opt_hash{todas}";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
      $refcircuito->{refvalores}->{GRAFICOS} = undef;
  };
  # en el hash apuntado por $refcircuito espera encontrar varias keys:
  my $paraplotSIMULADO = '';
  if ($refcircuito->{clasearch} eq 'circuito') {
      $paraplotSIMULADO = ident_simulado($refcircuito,$archguardar)
  };
  my ($paraplot, $haysimulado, @uniprilista) = ('',0,());
  #impr_debug(__LINE__.' Prog $refcircuito', Dumper $refcircuito);
  if (defined $refcircuito->{refvalores}->{GRAFICOS}) {
      my %todos = %{$refcircuito->{refvalores}->{GRAFICOS}}; 
      foreach (keys %todos) {
          my $vielista = $todos{$_};
          my @vielista = juntar_por_signos_y_paren(',', @$vielista);
	  #impr_debug(__LINE__.' Prog @vielista', \@vielista);
          my @pegados = grep (/=.*=/,@vielista);
          if (@pegados) { 
              avnoseent("Los \"renglones\" del cuadro GRAFICOS\n" .
                        join ("\n", @pegados) . "
             quizás un renglón terminado por error con coma 
                  se pegó al siguiente");
          };                     
          @vielista = grep($_!~ /=.*=/,@vielista);
	  #impr_debug(__LINE__.' Prog @vielista', \@vielista);

          @vielista and do{
               $paraplot = $paraplotSIMULADO . join("\n",@vielista). "\n"; 
          };
          $haysimulado += scalar (grep(/=\s*SIMULADO\s*\,/i,@vielista));
          push @uniprilista, grep(/unipri\s*SIMULADO/,@vielista);   
      }; #foreach 
      #impr_debug(__LINE__.' Prog $haysimulado @uniprilista',
      #        , [$haysimulado, @uniprilista]);
      $haysimulado and @uniprilista == 0 and
          $paraplot .= "unipri SIMULADO = $unidadtiempo\n";  
      #impr_debug(__LINE__.' Prog $paraplot', $paraplot); 
  } else {
      (my $paraplottextos,$haysimulado)
           = inventar_graficos($refcircuito, $archguardar);
      if ($paraplottextos) {
          $paraplot = "$paraplotSIMULADO$paraplottextos";
      } else {
          mensaje("No hay pedido de gráficos, directo ni por defecto");
          comfin('fin prograficar');
          return 1;
      };
  };
  #impr_debug(__LINE__.' Prog $paraplot $archguardarcongnus'
  #              ,[$paraplot,$archguardarcongnus]);
  if ($paraplot){ 
      open (PARAPLOT, ">$archguardarcongnus.paraplot");
      print PARAPLOT "# Archivo $archguardar.paraplot; preparado por $progname
# a partir del archivo $PROPIO  de fecha $date
#         para pedir gráficos a simusol3.pl\n";
      print PARAPLOT "$paraplot";
      close(PARAPLOT);
      comfin('fin prograficar');
      return 0;
  };       
}# prograficar
# ----------------------------------------------------------------------------
sub ident_simulado{
  my ($refcircuito, $archguardar, $archguardarconsimul) = @_; 
  #impr( __LINE__."Prog  propiasvar "
   #  , $refcircuito->{lispropiasvars});
  #impr( __LINE__."Prog  sceptre "
  #   , $refcircuito->{lisoutputssceptre});
  my $archivo = $refcircuito->{CORTO};
  my ($sceptrevars,$unidades,$propias,$magnitudes) = ('','','','');
  my $paraplotSIMULADO = '';
  $sceptrevars = join ',',@{$refcircuito->{lisoutputssceptre}};
  $propias = join ',',@{$refcircuito->{lispropiasvars}};
  my @lisunidades = @{$refcircuito->{lisunidades}};
  $lisunidades[0]= 'seg';
  $unidades =  join ',',@lisunidades;
  $magnitudes =  join ',',@{$refcircuito->{lismagnitudes}}; 
  my @indicebueno = @{$refcircuito->{indicebueno}};
  my @lista =  @{$refcircuito->{lispropiasvars}};
  for (my $i = 0; $i < @lista; $i ++) {
      $lista[$i] =~ s/\s//g;
          $nombreshash{uc($lista[$i])} = $i+1;
  };
  $paraplotSIMULADO =  "sceptrevars SIMULADO = $sceptrevars\n" .  
        "archivo SIMULADO = $archguardar.simul\n" .
        "variables SIMULADO = $propias\n" .
        "unidades  SIMULADO = $unidades\n" .
        "magnitudes SIMULADO = $magnitudes\n";
  #sceptrevars  lo usa simusol2.pl;  pero no simusol3.pl salvo que se deje 
  #indices SIMULADO = 1,...
  my $referencia = '';
  if (not grep('??',@lista)) {$referencia = 1; 
      # significa que hay errores en los pedidos
  } else { 
      for(my $i = 0; $i < @indicebueno; $i ++) {
	  $indicebueno[$i] ne $i+1 and $referencia = 1;
      };
  };
  if ($referencia) {
      my $tira = join ', ', @indicebueno;
      $paraplotSIMULADO .= "indices SIMULADO = $tira\n";  
  };
  #impr_debug(__LINE__.' Prog rerun', Dumper $refcircuito->{rerun});
  if (scalar keys %{$refcircuito->{rerun}} 
       and  defined $refcircuito->{marcasrerun} 
       and $refcircuito->{marcasrerun}) {
        $paraplotSIMULADO .= 
            "arch_var SIMULADO = $refcircuito->{archrerun}\n";
        $paraplotSIMULADO
          .= "variaciones SIMULADO = $refcircuito->{marcasrerun}\n"
   };
  return $paraplotSIMULADO;  
} #ident_simulado
# ----------------------------------------------------------------------------
sub inventar_graficos{
  comfin('com inventar_graficos',@_);
  my ($refcircuito,$archguardar) = $_[0];
  my $PROPIO = $refcircuito->{PROPIO};
  my $ngraf = 'graf00';
  my ($NGRAF,%textos,$todotextos, @simbograf,$textojuntos);
  my $mens_sincuadro = "---- Recuerde que puede:
               pedir gráficos en un cuadro GRAFICOS 
               o pedir gráficos en forma interactiva ejecutando
                    simusol -graf 1 $PROPIO" ;
  our @mens = split "\n", $mens_sincuadro;		     
  my @lisunidades = @{$refcircuito->{lisunidades}};
  my @lismagnitudes = @{$refcircuito->{lismagnitudes}};
  my @lispropiasvars = @{$refcircuito->{lispropiasvars}};
  my @lisoutputssceptres = @{$refcircuito->{lisoutputssceptre}};
  my @indicebueno = @{$refcircuito->{indicebueno}};
  #impr_resultados(__LINE__.' Prog inv.gra', $refcircuito);
  foreach my $key (@{$refcircuito->{listalisnum}}) {
      #%{$refcircuito->{lisnum}} :
      #key: el par de nombre de magnitud, unidad; 
      #value: la lista de los numeros de variables 
      #que corresponden a esa magnitud
      my ($coderr,$nombre,$uni) = juntar_por_paren(','
              ,split('\s*,\s*', $key));
      #impr_debug(__LINE__.' Prog $uni $nombre', "$uni, $nombre");
      $uni =~ s/\s*\S+\s+(\S+)/$1/; # el eventual factor quedará registrado
      #en las unidades, en el archivo .paraplot 
      if (not defined $refcircuito->{lisnum}->{$key}) {
          avnograv("Hay mezcla no conveniente de elementos de 
              plantillas distintas");
          next;
      };
      $ngraf ++;
      $NGRAF = uc($ngraf);
      my $listita = join ',', @{$refcircuito->{lisnum}->{$key}};
      push @simbograf, $NGRAF;
      $textos{$key} = "lineas $NGRAF = SIMULADO, 1 : $listita\n"; 
      $todotextos .= $textos{$key}; 
  }; # 
  my $juntotextos='';
  for (my $gg= 0; $gg< @simbograf; $gg += 2) {
      last if $gg+1 == @simbograf;
      $ngraf ++; $NGRAF = uc($ngraf);
      $textojuntos .=
            "mostrarjuntos $NGRAF = $simbograf[$gg], $simbograf[$gg+1]\n"
           . "nomostrar $simbograf[$gg], $simbograf[$gg+1]\n";
  }; 
  map ($juntotextos .= "echo $NGRAF = $_\n", @mens); 
  my $agregartextos = ''; my @uniprilista; 
  if (defined $refcircuito->{refvalores}->{AGREGAR_GRAFICOS} ) {
      my %todos = %{$refcircuito->{refvalores}->{AGREGAR_GRAFICOS}}; 
      foreach (keys %todos) {
          my $vielista = $todos{$_};
          my @vielista = juntar_por_signos_y_paren(',', @$vielista);
          my @pegados = grep (/=.*=/,@vielista);
         if (@pegados) { 
              avnoseent("Los \"renglones\" del cuadro AGREGAR_GRAFICOS\n" .
                        join ("\n", @pegados) . "
             quizás un renglón terminado por error con coma 
                  se pegó al siguiente");
          };                     
          @vielista = grep($_!~ /=.*=/,@vielista);
          @vielista and $agregartextos .= join ("\n", @vielista) ."\n";
          push @uniprilista, grep(/unipri\s*SIMULADO/,@vielista);   
      };
  };
  @uniprilista == 0 and $agregartextos .= "unipri SIMULADO = $unidadtiempo\n"; 
  comfin('fin inventar_graficos',@_);
  return "$textojuntos$todotextos$agregartextos";
  #va primero $textojuntos para mostrar primero los dobles graficos
} #inventar_graficos
# -----------------------------------------------------------------------
1
